// Copyright (C) 2003, 2005 Daisuke Arai <darai@users.sourceforge.jp>
// Copyright (C) 2008 panacoran <panacoran@users.sourceforge.jp>
// 
// This program is part of Protra.
//
// Protra is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, see <http://www.gnu.org/licenses/>.
// 
// $Id: ExpressionNode.cs 263 2010-01-16 13:12:35Z panacoran $

using System;
using System.Collections.Generic;

namespace Protra.Lib.Lang
{
	/// <summary>
	/// ̃m[h\NXB
	/// </summary>
	public class ExpressionNode : Node
	{
        /// <summary>
        /// 鎮̃m[hB
        /// </summary>
        private Node lvalueNode;
        /// <summary>
        /// 鎮̃m[hB
        /// </summary>
        private Node rvalueNode;

		/// <summary>
		/// \͂B
		/// </summary>
		/// <exception cref="Protra.Lib.Lang.ParseException">
		/// \͒ɃG[ƂthrowB
		/// </exception>
        /// <return>
        /// ͂ʂ̃m[hB
        /// </return>
		public override Node Parse()
		{
            Token = Scanner.Token;
            if (Token.Type == TokenType.LocalVariable && Scanner.Peek().Value == "=")
            {
                // [JϐL\ɓo^B
                Dictionary<string, int> lvt = LvtStack.Peek();
                if (!lvt.ContainsKey(Token.Value))
                    lvt[Token.Value] = lvt.Count;
            }
            Node node = new LogicalExpressionNode().Parse();
            if (Scanner.Token.Value != "=")
                return node;
            if (!(node is VariableNode || node is SuffixedExpressionNode))
                throw new RuntimeException("invalid assignment.", Token);
            lvalueNode = node;
            Scanner.Scan();
            rvalueNode = new ExpressionNode().Parse();
            return this;
		}

		/// <summary>
		/// vOsB
		/// </summary>
		/// <exception cref="Protra.Lib.Lang.RuntimeException">
		/// vOsɃG[ꍇthrowB
		/// </exception>
		/// <param name="resource">\[X</param>
		/// <param name="at">@pf̒l</param>
		/// <returns>s</returns>
		public override Value Execute(Resource resource, int at)
		{
            Value val = rvalueNode.Execute(resource, at);
            if (lvalueNode is VariableNode)
                return ((VariableNode)lvalueNode).Assign(resource, val);
            if (lvalueNode is SuffixedExpressionNode)
                return ((SuffixedExpressionNode)lvalueNode).Assign(resource, at, val);
            throw new RuntimeException("invalid assignment.", Token);
		}
	}
}
